--- old/usr/src/cmd/ptools/pargs/pargs.c	2016-04-26 13:38:45.737570364 +0200
+++ new/usr/src/cmd/ptools/pargs/pargs.c	2016-04-26 13:38:45.741130651 +0200
@@ -84,6 +84,7 @@
 	uintptr_t *pd_argv;
 	char **pd_argv_strs;
 	size_t pd_envc;
+	size_t pd_envc_curr;
 	uintptr_t *pd_envp;
 	char **pd_envp_strs;
 	size_t pd_auxc;
@@ -634,6 +635,10 @@
 	pargs_data_t *datap = data;
 
 	if (datap->pd_envp != NULL) {
+		/* env has more items than last time, skip the newer ones */
+		if (datap->pd_envc > datap->pd_envc_curr)
+			return (0);
+
 		datap->pd_envp[datap->pd_envc] = addr;
 		if (str == NULL)
 			datap->pd_envp_strs[datap->pd_envc] = NULL;
@@ -653,6 +658,7 @@
 
 	datap->pd_envc = 0;
 	(void) Penv_iter(pr, build_env, datap);
+	datap->pd_envc_curr = datap->pd_envc;
 
 	datap->pd_envp = safe_zalloc(sizeof (uintptr_t) * datap->pd_envc);
 	datap->pd_envp_strs = safe_zalloc(sizeof (char *) * datap->pd_envc);
